Subject: Re: bug#11339: 24.1.50; read-{buffer,file-name}-completion-ignore-case fails on non-ascii

From: Stephen Berman <[email-masked]>
Date: Fri, 01 Nov 2019 23:37:54 +0100

On Fri, 01 Nov 2019 22:20:42 +0200 Eli Zaretskii <[email-masked]> wrote:

>> From: Stefan Kangas <[email-masked]>
>> Date: Fri, 01 Nov 2019 20:57:30 +0100
>> Cc: [email-masked]
>> 
>> > 0. emacs -Q
>> > 1. M-x customize-option RET read-buffer-completion-ignore-case RET.
>> >    Toggle to "on", set for the current session.
>> >    M-x customize-option RET read-file-name-completion-ignore-case RET.
>> >    Toggle to "on", set for the current session.
>> > 2. C-x C-f b TAB => *Completions* buffer contains, as expected: bla bÄh
>> > bäh.
>> > 3. Visit files `bla', `bäh' and `bÄh', switch to buffer *scratch* and
>> >    repeat step 2, replacing `C-x C-f' with `C-x b' => same results.
>> > 4. C-x C-f bä TAB => Emacs completes the input to "bäh".               
>> > 5. TAB => Emacs incorrectly reports: "[Sole completion]".                 
>> > 6. C-x C-f bÄ TAB => Emacs completes the input to "bÄh".
>> > 7. TAB => Emacs incorrectly reports: "[Sole completion]".                 
>> > 8. Switch to buffer *scratch* and repeat step 4-7, replacing `C-x C-f'
>> >    with `C-x b' => same results.
>> 
>> I can reproduce this on current master using the simpler recipe:
>> 
>> 0. emacs -Q
>> 1. Evaluate (setq read-buffer-completion-ignore-case t)
>> 2. C-x b bäh RET
>> 3. C-x b bÄh RET
>> 4. C-x b bä TAB TAB
>> 
>> Result: Completes to "bäh" on first TAB, and on second TAB [Sole
>> completion] is displayed in minibuffer.
>> 
>> Expected result: The "*Completion*" buffer is displayed.
>
> I think your expectations are incorrect in this case.  Try having
> buffer names that differ (not in letter-case) in the 3rd letter.
>
> What I see here is entirely expected and reasonable.  I see no bug.

I think the expectation I had about the variables
read-{buffer,file-name}-completion-ignore-case was that they allow
getting information with less effort, in that by typing either a lower
or an upper case character, you would see names that have either or both
cases.  And that is apparently what I (thought I) had experienced with
ASCII characters but not with non-ASCII characters, which I assume is
what prompted my OP.  Unfortunately, the recipe in my OP did not include
the `bah' and `bAh' cases as a sanity check, and now I find the same
behavior with them as reported above for the non-ASCII cases.  So it
seems either the handling of the ASCII cases has changed since my OP, or
I was mistaken at the time in thinking there was a difference.  I also
followed up my OP more than a year later, reporting that the bug still
existed and adding a further observation
(https://lists.gnu.org/archive/html/bug-gnu-emacs/2013-07/msg00340.html).
And regarding the latter, on recent master that does indeed show a
difference between ASCII and non-ASCII characters:

0. touch /tmp/{bah,bAG,bäh,bÄg}
1. emacs-master -Q --eval '(setq read-buffer-completion-ignore-case t read-file-name-completion-ignore-case t)' /tmp/{bah,bAg,bäh,bÄg}
2. C-x b *scratch*
3a. C-x b ba TAB
   => *Completions* pops up showing `bAg' and `bah'
3b. C-x b bA TAB
   => *Completions* pops up showing `bAg' and `bah'
4a. C-g C-x b bä TAB
   => *Completions* pops up showing `bÄg' and `bäh'
4b. C-g C-x b bÄ TAB
   => *Completions* pops up showing `bÄg' and `bäh'
5a. C-g C-x C-f /tmp/ba TAB
   => *Completions* pops up showing `bAg' and `bah'
5b. C-g C-x C-f /tmp/bA TAB
   => *Completions* pops up showing `bAg' and `bah'
6a. C-g C-x C-f /tmp/bä TAB
  => completes to /tmp/bäh
6a. C-g C-x C-f /tmp/bÄ TAB
  => completes to /tmp/bÄg

Steve Berman